-------------------------------------------------------------------------------------
--  File Name   : clk_check_process.vht
--  Function    : NbNĎH  eXgx`
--  Author      : F.O (ProXi)
-- ylz     : {\[X Quartus II (Altera)   test bench template Writer 
--                t@CҏŴłB
-------------------------------------------------------------------------------------
LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

ENTITY clk_check_process_vhd_tst IS
END clk_check_process_vhd_tst;
ARCHITECTURE clk_check_process_arch OF clk_check_process_vhd_tst IS
-- constants                                                 
   constant clk0_period     : time := 50 ns;        -- 20 MHz
   constant clk1_period     : time := 101.725 ns;   -- 9.8304 MHz

-- signals                                                   
SIGNAL a_clk_down0      : STD_LOGIC;
SIGNAL a_clk_down1      : STD_LOGIC;
SIGNAL a_rst            : STD_LOGIC;
SIGNAL ah_clk_down0     : STD_LOGIC;
SIGNAL ah_clk_down1     : STD_LOGIC;
SIGNAL clk0             : STD_LOGIC;
SIGNAL clk1             : STD_LOGIC;

signal usec_time_cnt    : integer range 0 to 250 := 0;   -- uSec time_counter

COMPONENT clk_check_process
	PORT (
	a_clk_down0     : OUT STD_LOGIC;
	a_clk_down1     : OUT STD_LOGIC;
	a_rst           : IN STD_LOGIC;
	ah_clk_down0    : OUT STD_LOGIC;
	ah_clk_down1    : OUT STD_LOGIC;
	clk0            : IN STD_LOGIC;
	clk1            : IN STD_LOGIC
	);
END COMPONENT;
BEGIN
	i1 : clk_check_process
	PORT MAP (
    	a_clk_down0     => a_clk_down0,
	    a_clk_down1     => a_clk_down1,
	    a_rst           => a_rst,
	    ah_clk_down0    => ah_clk_down0,
	    ah_clk_down1    => ah_clk_down1,
	    clk0            => clk0,
	    clk1            => clk1
	);

    ---------------------------------------
    -- system reset
    a_rst  <= '1', '0' after 1 us;          -- VXeZbg

    -- uSec ^CJE^
    time_count_process : process begin
        while (usec_time_cnt < 300) loop
            wait for 1 us;
            usec_time_cnt <= usec_time_cnt + 1;
        end loop;
        wait;

    end process;

    -- clk0 
    clk0_generate_proces : process begin
        while (usec_time_cnt < 5) loop
            clk0 <= '1';                    -- clk0 
            wait for clk0_period /2;
            clk0 <= '0';
            wait for clk0_period /2;
        end loop;

        clk0 <= '0';                        -- clk0 _E '0'
        wait for 3 us;

        while (usec_time_cnt < 12) loop
            clk0 <= '1';                    -- clk0 
            wait for clk0_period /2;
            clk0 <= '0';
            wait for clk0_period /2;
        end loop;

        clk0 <= '1';                        -- clk0 _E '1'
        wait for 3 us;

        while (usec_time_cnt < 50) loop
            clk0 <= '1';                    -- clk0 
            wait for clk0_period /2;
            clk0 <= '0';
            wait for clk0_period /2;
        end loop;

        wait;

    end process;

      -- clk1 
    clk1_generate_proces : process begin
        while (usec_time_cnt < 20) loop
            clk1 <= '1';                    -- clk1 
            wait for clk1_period /2;
            clk1 <= '0';
            wait for clk1_period /2;
        end loop;

        clk1 <= '0';                        -- clk1 _E '0'
        wait for 3 us;

        while (usec_time_cnt < 27) loop
            clk1 <= '1';                    -- clk1 
            wait for clk1_period /2;
            clk1 <= '0';
            wait for clk1_period /2;
        end loop;

        clk1 <= '1';                        -- clk1 _E '1'
        wait for 3 us;

        while (usec_time_cnt < 50) loop
            clk1 <= '1';                    -- clk1 
            wait for clk1_period /2;
            clk1 <= '0';
            wait for clk1_period /2;
        end loop;

        wait;

    end process;

END clk_check_process_arch;
