-------------------------------------------------------------------------------------
--  File Name   : clock_monitor.vhd
--  Function    : NbNĎ{H
--  Author      : F.O (ProXi)
-- ylz     : {\[X ASIANL@ (Attributed SIgnAl Naming)  ŋLqĂB
--              :   ڍׂ http://www.proxi.co.jp/technolo/asian.pdf Q
-------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------
--  NbNĎ{H
-------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity clock_monitor is
    generic (WIDTH : integer := 5);             -- ĎpJE^rbg  iMSB̓JEgɂ͊^Ȃj
    port (
      -- in
        a_rst               : in  std_logic;    -- 񓯊Zbg
        base_clk            : in  std_logic;    -- Ďpx[XNbN
        a_monitored_clk     : in  std_logic;    -- ĎNbNi񓯊j
      -- out
        a_clk_down_status   : out std_logic;    -- NbN~z[hóibase_clkɓj
        ah_clk_down         : out std_logic     -- NbN~z[hói񓯊j
    );
end;

architecture rtl of clock_monitor is
    signal xa_clk_down_status   : std_logic;
    signal xah_clk_down         : std_logic;

    signal xav_cnt0             : std_logic_vector(WIDTH-1 downto 0);   -- NbN~ĎpJE^0
    signal xav_cnt1             : std_logic_vector(WIDTH-1 downto 0);   -- NbN~ĎpJE^1
        ----  xav_cnt0, xav_cnt1  a_rst ȊO a_monitored_clk MłŃNÂŔ񓯊JE^ƌȂ
    
begin
    -- NbN~ĎpJE^0    iĎNbN~'0'Ԍpoj
    process (a_rst, base_clk, a_monitored_clk) begin
        if (a_rst = '1') then
            xav_cnt0 <= (others => '0');
        elsif (a_monitored_clk = '1') then                  -- ĎNbN'1'ŃJE^񓯊NA
            xav_cnt0 <= (others => '0');
        elsif (base_clk'event and base_clk = '1') then      -- ĎNbN'0'ŃJEg
            if (xav_cnt0(WIDTH-1) = '0') then               -- JE^MSB'0'ŕiA'1'ŃJEgAbvƂĕi~
                xav_cnt0 <= xav_cnt0 + '1';
            end if;
        end if;
    end process;

    -- NbN~ĎpJE^1    iĎNbN~'1'Ԍpoj
    process (a_rst, base_clk, a_monitored_clk) begin
        if (a_rst = '1') then
            xav_cnt1 <= (others => '0');
        elsif (a_monitored_clk = '0') then                  -- ĎNbN'0'ŃJE^񓯊NA
            xav_cnt1 <= (others => '0');
        elsif (base_clk'event and base_clk = '1') then      -- ĎNbN'1'ŃJEg
            if (xav_cnt1(WIDTH-1) = '0') then               -- JE^MSB'0'ŕiA'1'ŃJEgAbvƂĕi~
                xav_cnt1 <= xav_cnt1 + '1';
            end if;
        end if;
    end process;

    -- NbN~z[hM
    xa_clk_down_status <= xav_cnt0(WIDTH-1) or xav_cnt1(WIDTH-1);

    -- NbN~z[hM  i񓯊b`j
    process (a_rst, xa_clk_down_status) begin
        if (a_rst = '1') then
            xah_clk_down <= '0';
        elsif (xa_clk_down_status'event and xa_clk_down_status = '1') then
            xah_clk_down <= '1';
        end if;
    end process;

    -- o͐MZbg
    a_clk_down_status   <= xa_clk_down_status;
    ah_clk_down         <= xah_clk_down;

end rtl;

